<?php
/*
* Project:     Morgdkp2 eqdkp plus plug-in
* License:     Creative Commons - Attribution-Noncommercial-Share Alike 3.0 Unported
* Link:    http://creativecommons.org/licenses/by-nc-sa/3.0/
* -----------------------------------------------------------------------
* Began:       2013
* -----------------------------------------------------------------------
* @author      BlueWarlord
* @copyright   2013-
* Based upon the EQdkp-Plus epgpimport plug-in and Morgalm's original morgdkp 2 plug-in for eqkdp plus 0.6
*/

// no direct usage
if (!defined('EQDKP_INC'))
{
	die('You cannot access this file directly.');
}

// declare the plugin class
class morgdkp2 extends plugin_generic
{
  
	public static function __shortcuts() {
		$shortcuts = array('core', 'user', 'db', 'pdh', 'config');
		return array_merge(parent::$shortcuts, $shortcuts);
	}
	
	public $vstatus = 'Alpha';
	public $version = '0.1.0';
	public $parser_version = "3.3";
	
	/* Create the SQL tables the plug-in needs */
	public function pre_install() {  
		$sqls = $this->create_install_sqls();
		foreach($sqls as $sql) {
			$this->add_sql(SQL_INSTALL, $sql);
		}
	}
	
	/* Remove the sql tables of the plug-in */
	public function pre_uninstall() {
		$sqls = $this->create_uninstall_sqls();
		foreach($sqls as $sql) {
			$this->add_sql(SQL_UNINSTALL, $sql);
		}
	}
	
	public function __construct() {
		parent::__construct();
	
		$this->add_dependency(array(
			'plus_version' => '1.0',
			'games'  => array('wow')
		));
	
		$this->add_data(array(
				'name'        		=> 'Morgdkp 2 plugin',
				'code'       		=> 'morgdkp2',
				'path'        		=> 'morgdkp2',
				'contact'      		=> 'http://www.wowace.com/addons/morg-dkp2/',
				'template_path' 	=> 'plugins/morgdkp2/templates/',
				'version'      		=> $this->version,
				'author'      		=> 'BlueWarlord',
				'description'   	=> $this->user->lang('morgdkp2_short_desc'),
				'long_description'  	=> $this->user->lang('morgdkp2_long_desc'),
				'homepage'      	=> 'http://www.wowace.com/addons/morg-dkp2/',
				'manuallink'    	=> 'http://www.wowace.com/addons/morg-dkp2/pages/introduction/',
				'icon'        		=> $this->root_path.'plugins/morgdkp2/images/morgdkp2.png',
			)
		);
	
		//permissions,  2 = Super-Admin, undeletable, 3 = Admins, undeletable 
		$this->add_permission('a', 'export', 'N', $this->user->lang('morgexport_export'), array(2,3));
		$this->add_permission('a', 'import', 'N', $this->user->lang('morgimport_import'), array(2,3));
		
		
		//menu
		$this->add_menu('admin_menu', $this->gen_admin_menu());
	}
	
	
	function gen_admin_menu(){
		$admin_menu = array(array(
			'icon' => './../../plugins/morgdkp2/images/morgdkp2.png',
			'name' => $this->user->lang('morgdkp2_adminmenu_title'),
			1 => array(
				'link' => 'plugins/' . $this->code . '/admin/export.php'.$this->SID,
				'text' => $this->user->lang('morgexport_export'),
				'check' => 'a_morgdkp2_export',
				'icon' => './../../plugins/morgdkp2/images/export.png'),
			
			2 => array(
				'link' => 'plugins/' . $this->code . '/admin/import.php'.$this->SID,
				'text' => $this->user->lang('morgimport_import'),
				'check' => 'a_morgdkp2_import',
				'icon' => './../../plugins/morgdkp2/images/import.png')
			));
		
		return $admin_menu;
	}
	
	/**
	* Create the sql statements used to initialize the plugin. At this point, 
	* this is only the table to track aliases    
	*/
	private function create_install_sqls() {
		$install_sqls = array(
			"CREATE TABLE IF NOT EXISTS `__ctrt_aliases` (
			`alias_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
			`alias_member_id` mediumint(9) NOT NULL DEFAULT '0',
			`alias_name` varchar(50) NOT NULL DEFAULT '',
			PRIMARY KEY (`alias_id`)
			) DEFAULT CHARSET=utf8 COLLATE=utf8_bin;" );      
		
		return $install_sqls;
	}
	
	/**
	* Remove the sql that the plug-in created. 
	*/
	
	private function create_uninstall_sqls() {
		$uninstall_sqls = array(
			"DROP TABLE IF EXISTS __ctrt_aliases;"
		);
		return $uninstall_sqls;
	}
  
}
if(version_compare(PHP_VERSION, '5.3.0', '<')) registry::add_const('short_morgdkp2', morgdkp2::__shortcuts());
?>
